git-am.shon commit git-am: --resolved. (0c15cc9)
   1#!/bin/sh
   2#
   3#
   4. git-sh-setup || die "Not a git archive"
   5
   6usage () {
   7    echo >&2 "usage: $0 [--signoff] [--dotest=<dir>] [--utf8] [--3way] <mbox>"
   8    echo >&2 "  or, when resuming"
   9    echo >&2 "  $0 [--skip | --resolved]"
  10    exit 1;
  11}
  12
  13stop_here () {
  14    echo "$1" >"$dotest/next"
  15    exit 1
  16}
  17
  18go_next () {
  19        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  20                "$dotest/patch" "$dotest/info"
  21        echo "$next" >"$dotest/next"
  22        this=$next
  23}
  24
  25fall_back_3way () {
  26    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
  27
  28    rm -fr "$dotest"/patch-merge-*
  29    mkdir "$dotest/patch-merge-tmp-dir"
  30
  31    # First see if the patch records the index info that we can use.
  32    if git-apply -z --index-info "$dotest/patch" \
  33        >"$dotest/patch-merge-index-info" 2>/dev/null &&
  34        GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  35        git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
  36        GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  37        git-write-tree >"$dotest/patch-merge-base+" &&
  38        # index has the base tree now.
  39        (
  40            cd "$dotest/patch-merge-tmp-dir" &&
  41            GIT_INDEX_FILE="../patch-merge-tmp-index" \
  42            GIT_OBJECT_DIRECTORY="$O_OBJECT" \
  43            git-apply --index <../patch
  44        )
  45    then
  46        echo Using index info to reconstruct a base tree...
  47        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
  48        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
  49    else
  50        # Otherwise, try nearby trees that can be used to apply the
  51        # patch.
  52        (
  53            N=10
  54
  55            # Hoping the patch is against our recent commits...
  56            git-rev-list --max-count=$N HEAD
  57
  58            # or hoping the patch is against known tags...
  59            git-ls-remote --tags .
  60        ) |
  61        while read base junk
  62        do
  63            # See if we have it as a tree...
  64            git-cat-file tree "$base" >/dev/null 2>&1 || continue
  65
  66            rm -fr "$dotest"/patch-merge-* &&
  67            mkdir "$dotest/patch-merge-tmp-dir" || break
  68            (
  69                cd "$dotest/patch-merge-tmp-dir" &&
  70                GIT_INDEX_FILE=../patch-merge-tmp-index &&
  71                GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
  72                export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
  73                git-read-tree "$base" &&
  74                git-apply --index &&
  75                mv ../patch-merge-tmp-index ../patch-merge-index &&
  76                echo "$base" >../patch-merge-base
  77            ) <"$dotest/patch"  2>/dev/null && break
  78        done
  79    fi
  80
  81    test -f "$dotest/patch-merge-index" &&
  82    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
  83    orig_tree=$(cat "$dotest/patch-merge-base") &&
  84    rm -fr "$dotest"/patch-merge-* || exit 1
  85
  86    echo Falling back to patching base and 3-way merge...
  87
  88    # This is not so wrong.  Depending on which base we picked,
  89    # orig_tree may be wildly different from ours, but his_tree
  90    # has the same set of wildly different changes in parts the
  91    # patch did not touch, so resolve ends up cancelling them,
  92    # saying that we reverted all those changes.
  93
  94    git-merge-resolve $orig_tree -- HEAD $his_tree || {
  95            echo Failed to merge in the changes.
  96            exit 1
  97    }
  98}
  99
 100prec=4
 101dotest=.dotest sign= utf8= keep= skip= interactive= resolved=
 102
 103while case "$#" in 0) break;; esac
 104do
 105        case "$1" in
 106        -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
 107        dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
 108        -d|--d|--do|--dot|--dote|--dotes|--dotest)
 109        case "$#" in 1) usage ;; esac; shift
 110        dotest="$1"; shift;;
 111
 112        -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
 113        --interacti|--interactiv|--interactive)
 114        interactive=t; shift ;;
 115
 116        -3|--3|--3w|--3wa|--3way)
 117        threeway=t; shift ;;
 118        -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
 119        sign=t; shift ;;
 120        -u|--u|--ut|--utf|--utf8)
 121        utf8=t; shift ;;
 122        -k|--k|--ke|--kee|--keep)
 123        keep=t; shift ;;
 124
 125        -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
 126        resolved=t; shift ;;
 127
 128        --sk|--ski|--skip)
 129        skip=t; shift ;;
 130
 131        --)
 132        shift; break ;;
 133        -*)
 134        usage ;;
 135        *)
 136        break ;;
 137        esac
 138done
 139
 140# If the dotest directory exists, but we have finished applying all the
 141# patches in them, clear it out.
 142if test -d "$dotest" &&
 143   last=$(cat "$dotest/last") &&
 144   next=$(cat "$dotest/next") &&
 145   test $# != 0 &&
 146   test "$next" -gt "$last"
 147then
 148   rm -fr "$dotest"
 149fi
 150
 151if test -d "$dotest"
 152then
 153        test ",$#," = ",0," ||
 154        die "previous dotest directory $dotest still exists but mbox given."
 155        resume=yes
 156else
 157        # Make sure we are not given --skip nor --resolved
 158        test ",$skip,$resolved," = ,,, ||
 159                die "we are not resuming."
 160
 161        # Start afresh.
 162        mkdir -p "$dotest" || exit
 163
 164        # cat does the right thing for us, including '-' to mean
 165        # standard input.
 166        cat "$@" |
 167        git-mailsplit -d$prec "$dotest/" >"$dotest/last" || {
 168                rm -fr "$dotest"
 169                exit 1
 170        }
 171
 172        # -s, -u and -k flags are kept for the resuming session after
 173        # a patch failure.
 174        # -3 and -i can and must be given when resuming.
 175        echo "$sign" >"$dotest/sign"
 176        echo "$utf8" >"$dotest/utf8"
 177        echo "$keep" >"$dotest/keep"
 178        echo 1 >"$dotest/next"
 179fi
 180
 181case "$resolved" in
 182'')
 183        files=$(git-diff-index --cached --name-only HEAD) || exit
 184        if [ "$files" ]; then
 185           echo "Dirty index: cannot apply patches (dirty: $files)" >&2
 186           exit 1
 187        fi
 188esac
 189
 190if test "$(cat "$dotest/utf8")" = t
 191then
 192        utf8=-u
 193fi
 194if test "$(cat "$dotest/keep")" = t
 195then
 196        keep=-k
 197fi
 198if test "$(cat "$dotest/sign")" = t
 199then
 200        SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
 201                        s/>.*/>/
 202                        s/^/Signed-off-by: /'
 203                `
 204else
 205        SIGNOFF=
 206fi
 207
 208last=`cat "$dotest/last"`
 209this=`cat "$dotest/next"`
 210if test "$skip" = t
 211then
 212        this=`expr "$this" + 1`
 213fi
 214
 215if test "$this" -gt "$last"
 216then
 217        echo Nothing to do.
 218        rm -fr "$dotest"
 219        exit
 220fi
 221
 222while test "$this" -le "$last"
 223do
 224        msgnum=`printf "%0${prec}d" $this`
 225        next=`expr "$this" + 1`
 226        test -f "$dotest/$msgnum" || {
 227                go_next
 228                continue
 229        }
 230
 231        # If we are not resuming, parse and extract the patch information
 232        # into separate files:
 233        #  - info records the authorship and title
 234        #  - msg is the rest of commit log message
 235        #  - patch is the patch body.
 236        #
 237        # When we are resuming, these files are either already prepared
 238        # by the user, or the user can tell us to do so by --resolved flag.
 239        case "$resume" in
 240        '')
 241                git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
 242                        <"$dotest/$msgnum" >"$dotest/info" ||
 243                        stop_here $this
 244                git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
 245                ;;
 246        esac
 247
 248        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 249        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 250        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 251        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 252
 253        SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
 254        case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
 255
 256        case "$resume" in
 257        '')
 258            if test '' != "$SIGNOFF"
 259            then
 260                LAST_SIGNED_OFF_BY=`
 261                    sed -ne '/^Signed-off-by: /p' \
 262                    "$dotest/msg-clean" |
 263                    tail -n 1
 264                `
 265                ADD_SIGNOFF=`
 266                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 267                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 268                    echo "$SIGNOFF"
 269                }`
 270            else
 271                ADD_SIGNOFF=
 272            fi
 273            {
 274                echo "$SUBJECT"
 275                if test -s "$dotest/msg-clean"
 276                then
 277                        echo
 278                        cat "$dotest/msg-clean"
 279                fi
 280                if test '' != "$ADD_SIGNOFF"
 281                then
 282                        echo "$ADD_SIGNOFF"
 283                fi
 284            } >"$dotest/final-commit"
 285            ;;
 286        *)
 287                case "$resolved,$interactive" in
 288                tt)
 289                        # This is used only for interactive view option.
 290                        git-diff-index -p --cached HEAD >"$dotest/patch"
 291                        ;;
 292                esac
 293        esac
 294
 295        resume=
 296        if test "$interactive" = t
 297        then
 298            test -t 0 ||
 299            die "cannot be interactive without stdin connected to a terminal."
 300            action=again
 301            while test "$action" = again
 302            do
 303                echo "Commit Body is:"
 304                echo "--------------------------"
 305                cat "$dotest/final-commit"
 306                echo "--------------------------"
 307                echo -n "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 308                read reply
 309                case "$reply" in
 310                [yY]*) action=yes ;;
 311                [aA]*) action=yes interactive= ;;
 312                [nN]*) action=skip ;;
 313                [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
 314                       action=again ;;
 315                [vV]*) action=again
 316                       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
 317                *)     action=again ;;
 318                esac
 319            done
 320        else
 321            action=yes
 322        fi
 323
 324        if test $action = skip
 325        then
 326                go_next
 327                continue
 328        fi
 329
 330        if test -x "$GIT_DIR"/hooks/applypatch-msg
 331        then
 332                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 333                stop_here $this
 334        fi
 335
 336        echo
 337        echo "Applying '$SUBJECT'"
 338        echo
 339
 340        case "$resolved" in
 341        '')
 342                git-apply --index "$dotest/patch"
 343                apply_status=$?
 344                ;;
 345        t)
 346                # Resolved means the user did all the hard work, and
 347                # we do not have to do any patch application.  Just
 348                # trust what the user has in the index file and the
 349                # working tree.
 350                resolved=
 351                apply_status=0
 352                ;;
 353        esac
 354
 355        if test $apply_status = 1 && test "$threeway" = t
 356        then
 357                if (fall_back_3way)
 358                then
 359                    # Applying the patch to an earlier tree and merging the
 360                    # result may have produced the same tree as ours.
 361                    changed="$(git-diff-index --cached --name-only -z HEAD)"
 362                    if test '' = "$changed"
 363                    then
 364                            echo No changes -- Patch already applied.
 365                            go_next
 366                            continue
 367                    fi
 368                    # clear apply_status -- we have successfully merged.
 369                    apply_status=0
 370                fi
 371        fi
 372        if test $apply_status != 0
 373        then
 374                echo Patch failed at $msgnum.
 375                stop_here $this
 376        fi
 377
 378        if test -x "$GIT_DIR"/hooks/pre-applypatch
 379        then
 380                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 381        fi
 382
 383        tree=$(git-write-tree) &&
 384        echo Wrote tree $tree &&
 385        parent=$(git-rev-parse --verify HEAD) &&
 386        commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
 387        echo Committed: $commit &&
 388        git-update-ref HEAD $commit $parent ||
 389        stop_here $this
 390
 391        if test -x "$GIT_DIR"/hooks/post-applypatch
 392        then
 393                "$GIT_DIR"/hooks/post-applypatch
 394        fi
 395
 396        go_next
 397done
 398
 399rm -fr "$dotest"